﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Dim sv As ScrollView

	Private items, nombre, imagenurl As Map
	Private callback As Panel
	Private actividad As Object

	Dim columnas As Int = 2
	Dim columnaactual As Int = 0

	Private iv(1) As ImageView
	Private cuentaiv As Int=0
	Private totalregistros As Int

	Dim fondo As Panel
	Dim label As Label
	Private altopanel As Int

	Private anchoborde, fotosize, altotexto, tamañotexto, colorfondo, colortexto, posiciontexto As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(registros As Int, activity As Object, panel1 As Panel, colum As Int, altotext As Int, gravitytext As Int, textsize As Int, colortext As Int, backcolor As Int, borderpic As Int, scrollbarvisible As Boolean)
	callback=panel1
	columnas=colum
	actividad=activity
	totalregistros = registros

	nombre.Initialize
	imagenurl.Initialize
	items.Initialize

	Dim iv(registros+1) As ImageView

	sv.Initialize2(0, "sv")
	panel1.AddView(sv,0,0,panel1.Width,panel1.Height)

	altotexto= altotext
	fotosize = panel1.Width / colum
	tamañotexto = textsize
	colortexto = colortext
	colorfondo = backcolor
	anchoborde=borderpic
	posiciontexto=gravitytext
	
	Dim jo = sv As JavaObject
    jo.RunMethod("setVerticalScrollBarEnabled", Array As Object (scrollbarvisible))
End Sub

public Sub add(index As Int, name As String, imageurl As String)
	If columnaactual > columnas-1 Then columnaactual=0

	'posiciona elementos	
	Dim izq As Int = fotosize*columnaactual
	Dim fila As Int = nombre.Size/columnas
	columnaactual=columnaactual + 1
	'registra map elementos
	nombre.Put(nombre.Size,name)
	imagenurl.Put(imagenurl.Size,imageurl)
	items.Put(items.Size,index)

	fondo.Initialize("panel")
	sv.Panel.AddView(fondo,izq,((fotosize+altotexto)*fila),fotosize,fotosize+altotexto+anchoborde)
	fondo.Color=colorfondo
	fondo.Tag = index	
	
	Dim tamimag= ((fondo.width))-(anchoborde*columnas)
	cuentaiv=cuentaiv+1
	iv(cuentaiv).Initialize("iv")
	fondo.AddView(iv(cuentaiv),anchoborde,anchoborde,tamimag,tamimag)
	iv(cuentaiv).Tag = index
	iv(cuentaiv).Visible=False

	label.Initialize("")
	label.Text=name
	fondo.AddView(label,anchoborde,fotosize-(anchoborde*(columnas-1)),fondo.Width-(anchoborde*columnas),altotexto)
	label.TextColor=colortexto
	label.TextSize=tamañotexto
	label.Gravity=posiciontexto
	label.Color=Colors.white
	
	sv.panel.Height= (fila+1) * (fondo.height-anchoborde)
	altopanel=fondo.height-anchoborde
End Sub

Sub sv_ScrollChanged(index As Int)
	'Log(index)
	Dim fila As Int= (Round((index/altopanel)))+1
	Dim ivb As Int = fila*2
	Dim iva As Int = ivb-1

	For a=0 To 4
		If iva+a < totalregistros Then
			If iv(iva+a).IsInitialized Then
				If iv(iva+a).Visible=False Then cargaimagen(iva+a)
			End If
		End If
		If ivb+a < totalregistros Then
			If iv(ivb+a).IsInitialized Then
				If iv(ivb+a).Visible=False Then cargaimagen(ivb+a)
			End If
		End If
	Next
End Sub

Sub cargaimagen(indice As Int)
	GetPicasso.RunMethodJO("load", Array(imagenurl.Get(indice-1))).RunMethodJO("resize", Array(180, 180)).runmethodjo("skipMemoryCache",Null).RunMethodJO("centerCrop", Null).RunMethodJO("into", Array(iv(indice)))

	iv(indice).Visible=True
	GetPicasso.RunMethodJO("invalidate", Array(imagenurl.Get(indice-1)))

	iv(indice).Bitmap=Null
	iv(indice).SetBackgroundImage(Null)
	iv(indice).Invalidate
End Sub


Private Sub panel_Click
	If SubExists(actividad, "grid_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(actividad, "grid_ItemClick", v.Tag, items.Get(v.Tag))
	End If
End Sub


Sub remove
	callback.RemoveAllViews

End Sub



Sub Picasso_Event (MethodName As String, Args() As Object) As Object
   Return Null
'   If MethodName = "onSuccess" Then
'     ToastMessageShow("Success!!!", True)
'   Else If MethodName = "onError" Then
'     ToastMessageShow("Error downloading image.", True)
'   End If
'   Return Null
End Sub

Sub GetPicasso As JavaObject
   Dim jo As JavaObject
   'com.squareup.picasso.Picasso.with(context)
   Return jo.InitializeStatic("com.squareup.picasso.Picasso").RunMethod("with", Array(GetContext))
End Sub

Sub GetContext As JavaObject
   Return GetBA.GetField("context")
End Sub

Sub GetBA As JavaObject
  Dim jo As JavaObject
  Dim cls As String = actividad
  cls = cls.SubString("class ".Length)
  jo.InitializeStatic(cls)
  Return jo.GetFieldJO("processBA")
End Sub
